package require sqlite3
namespace eval ActiveRecord {
	Base instproc reference_type {field value converted} {
		upvar $converted _converted
		set data_type [string tolower [my column_attribute $field type]]
		switch -glob -- $data_type {
		varchar* {
			set type quote
		}
		text* {
			set type quote
		}
		bool* {
			set type convert
			set _converted '[expr [string is true $value] ? t : f]'
		}
		blob {
			set type reference
		}
		double*  {
			set type no-quote
		}
		*int*    {
			set type no-quote
		}
		default  {
			set type quote
		}
		}
		return $type
	}
	
	Base instproc connection_prepare {} {
		my instvar table db_interface db_connect_info dbinfo
		
		array set db_connect_info {
			sqlfile "db/infocard.db"
		}
		
		set db_interface [Sqlinterface loadInterface sqlite]
		
		set dbinfo(table_info_query)  "PRAGMA table_info($table)"
		set dbinfo(column_attributes) {cid field type nn dflt ai}
		set dbinfo(max_id_query)      "SELECT max(id) FROM $table"
		set dbinfo(begin)             "BEGIN"
		set dbinfo(rollback)          "ROLLBACK"
		set dbinfo(commit)            "COMMIT"
	}
}
